/*
 *  $Id$
 */

/**
 *  @file bt_discover.h
 *
 *  @project btChat (http://www.mulliner.org/bluetooth/btchat/)
 *
 *  @author Collin R. Mulliner <collin(AT)betaversion.net>
 *
 *  (c) Collin R. Mulliner
 *
 */

#ifndef __BT_DISCOVER_H__
#define __BT_DISCOVER_H__

struct btchat_discover_node_t {

	bdaddr_t addr;              /**< the nodes bluetooth device address */
	unsigned int device_class;  /**< the nodes bluetooth device service class */
	char name[250];             /**< the nodes bluetooth device name */
	
	short int btchat_channel;   /**< the btchat rfcomm channel */

	short int discovery_method; /**< method of device discovery */	
	
	time_t last;                /**< last time of contact */
	int updated;                /**< updated flag */
	
	int state;                  /**< state */
};

struct btchat_btdiscover_server_t {

	int s;         /**< socket */

	int bt_device; /**< the local bluetooth hci device */

	unsigned char buffer[1024]; /**< read buffer */
	unsigned int buffer_pos;    /**< position in buffer */
	unsigned int buffer_size;   /**< buffer size */
	
	struct tree_t btdevices; /**< tree with all known btdevices */
	
	time_t current_time;     /**< current time */
};

#endif

int bt_discover_server(int socket);
int bt_discover_client(struct btchatd_t *globals, struct pollfd *fd);

/*
 *  $Log$
 */
