/*
 *  $Id$
 */
 
/**
 *  @file bt_net.h
 *
 *  @project btChat (http://www.mulliner.org/bluetooth/btchat/)
 *
 *  @author Collin R. Mulliner <collin(AT)betaversion.net>
 *
 *  (c) Collin R. Mulliner
 *
 */

#ifndef __BT_NET_H__
#define __BT_NET_H__

struct btchat_connect_data_out_t {
	
	struct btchatd_t *g;
	struct btchat_node_t *n;
	int hops;
	int index;
	time_t time_index;
};

struct btchat_connect_data_in_t {

	int index;
	int socket;
	struct sockaddr_rc *sa;
	int sa_len;
};

struct btchat_route_disconnected_t {

	struct btchatd_t *g;
	int index;
	time_t cur_time;
};

struct btchat_route_publish_t {

	struct btchatd_t *g;
	int index;
	time_t cur_time;
};

#endif

int bt_client_connect(struct btchatd_t *globals);
int bt_node_update(struct btchatd_t *globals, void *n, int n_type, int src, struct btchat_node_t **out);
int bt_notify_net(struct btchatd_t *globals, struct btchat_node_t *node, int offline);
int bt_node_isconnected(struct btchat_node_t *n);

int bt_msg_send(struct btchatd_t *globals, int src, void *data, int data_leng);

int bt_route_broadcast(struct btchatd_t *globals, struct btchat_node_t *node, int src);
int bt_route_propagate(struct btchatd_t *globals, struct btchat_node_t *node, int src, int notify);
int bt_client_disconnected(struct btchatd_t *globals, int index);
int bt_route_publish(struct btchatd_t *globals, int index);
int bt_self_publish(struct btchatd_t *globals, int index);

/*
 *  $Log$
 */
