/*
 *  $Id$
 */
 
/**
 *  @file discover_protocol.h
 *
 *  @project btChat (http://www.mulliner.org/bluetooth/btchat/)
 *
 *  @author Collin R. Mulliner <collin(AT)betaversion.net>
 *
 *  (c) Collin R. Mulliner
 *
 */

#ifndef __DISCOVER_PROTOCOL_H__
#define __DISCOVER_PROTOCOL_H__

enum btcdiscover_protocol_pkgtype_t {
	btcdiscover_protocol_null = 0,
	btcdiscover_protocol_discover,
	btcdiscover_protocol_btchatdiscover,
	btcdiscover_protocol_device,
	btcdiscover_protocol_devinfo,
	btcdiscover_protocol_unknown = 255
};

struct btcdiscover_protocol_header_t {
	__uint8_t version;  /**< protocol version */
	__uint8_t pkg_type; /**< packet type - see btcclient_protocol_pkgtype_t */
	__uint32_t time;    /**< time at which packet was send (un*x time in seconds) */
	__uint16_t length;  /**< packet length, inclusive header */
};

struct btcdiscover_protocol_discover_t {
	__uint8_t inquiry_time; /**< inquiry duration */
	__uint8_t reserved[3];
};

struct btcdiscover_protocol_devinfo_t {
	__uint8_t addr[6];     /**< device bdaddr */
	__uint8_t reserved[2];
};

struct btcdiscover_protocol_device_t {
	__uint8_t addr[6];          /**< device bdaddr */
	__uint32_t device_class;    /**< bluetooth device class */
	__uint8_t name[250];        /**< bluetooth device name */
	__int8_t btchat_channel;    /**< btchat rfcomm channel (-1 if not available) */
	__uint8_t discovery_method; /**< method of device discovery */
	__uint16_t state;           /**< state  */
};

#endif

/*
 *  $Log$
 */
